import os
import pyRepetUnit.commons.coord.Align
import pyRepetUnit.align.AlignList
from pyRepet.util.file.FileUtils import *
#------------------------------------------------------------------------------

class AlignListUtils:  
  
    #--------------------------------------------------------------------------
    def read( inFileName ):
        """
        read a file in align format and return a AlignList
        """
        alignInstance = pyRepetUnit.commons.coord.Align.Align() 
        listAlignInstance = pyRepetUnit.align.AlignList.AlignList()
        f = open( inFileName , "r")
        while alignInstance.read( f ):
            listAlignInstance.append(alignInstance)
            alignInstance = pyRepetUnit.commons.coord.Align.Align()
        f.close
        return (listAlignInstance)
    
    read = staticmethod( read )
    
    #--------------------------------------------------------------------------
    def write( alignListInstance, inFileName ):
        """
        write a file in align format from an AlignList
        """
        f = open( inFileName , "w")
        for alignInstance in alignListInstance.getList():
            alignInstance.write( f )
        f.close
        
    write = staticmethod( write )
    
    #--------------------------------------------------------------------------    
    def filterOnAMinimalScore( listAlignInstance, minScore ):
        """
        Filter an AlignList by removing all is <= minScore
        """
        listAlignInstanceOld = pyRepetUnit.align.AlignList.AlignList() 
        for alignInstance in listAlignInstance.getList():  
             listAlignInstanceOld.append(alignInstance)
        for alignInstance in listAlignInstanceOld.getList():
            if alignInstance.score <= minScore:
                listAlignInstance.remove(alignInstance)
        
    filterOnAMinimalScore = staticmethod( filterOnAMinimalScore )    
    
if __name__ == "__main__":                 
    main() 
