##  A exception raised by check() method of class ConfigChecker
#
# This class allow storage of multiple messages (see messages attribute).
# Example: use one instance of ConfigException class for one section in config file.
# All messages relatives to this section are stored in messages attribute.
class ConfigException(Exception):
    
    ## Constructor
    #
    # @param msg message embeded in Execption class   
    # @param messages list of messages 
    #
    def __init__(self,msg, messages=[]):
        ## @var messages
        #  list of messages stored for this exception
        self.messages = messages
        Exception.__init__(self, msg)
